/* $Id: BaneOut.java,v 1.4 2007/08/31 01:14:43 mit Exp $ */
/* BaneOut.java v1.3 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class BaneOut extends Applet implements AdjustmentListener
{
    private Scrollbar scrP, scrQ, scrW;
    final int A = 2; // 
    int W;
    int H;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());

	Panel p = new Panel();
	p.setLayout(new GridLayout(3,2,0,0));

	scrP = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,60);
	p.add(scrP);
	scrP.addAdjustmentListener(this);

	p.add(new Label(" : P (Damper)"));

	scrQ = new Scrollbar(Scrollbar.HORIZONTAL,40,1,0,60);
	p.add(scrQ);
	scrQ.addAdjustmentListener(this);

	p.add(new Label(" : Q (Spring)"));

	scrW = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,60);
	p.add(scrW);
	scrW.addAdjustmentListener(this);

	p.add(new Label(" : W (Radian)"));

	add(p, "South");
    }
    public void start() {
	W = getSize().width;
	H = getSize().height;
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }
    public void paint (Graphics g) {
	int hx = (int)(H*5/6d); // Disp.size
	int hw = W/2;
	int hh = hx/2;
	int xofs = 10;
	int dh = (int)(H/3d);
	int t0 = 0;             // ֽ
	int tf = W;             // ǽ 
	double dx = tf/(W*20d); // 
	double y = 0d;          // ®
	double x = 0d;          // Ѱ (0)
	
	g.setColor(Color.black);
	g.fillRect(0,0,W,H);

	g.setColor(Color.blue);
	g.drawLine(0,hh,W,hh);
	g.drawLine(xofs,0,xofs,H);

	double p = scrP.getValue()/10d; // ѡ
	double q = scrQ.getValue()/10d; // Хͽ
	double r = scrW.getValue()/10d; // ư(饸)

	g.setColor(Color.red);
	g.drawString("P = "+p, 20, 10);
	g.drawString("Q = "+q, 80, 10);
	g.drawString("W = "+r, 140, 10);

	double t, k1, k2, k3, k4, l1, l2, l3, l4;
	g.setColor(Color.green);
	for (int i = t0; i < tf; i++) {
	    g.drawOval(i+xofs, (int)(hh-x*dh), 1,1);

	    t = i*dx;
	    k1 = dx * fnk(y);
	    l1 = dx * fnl(t, y, x, p, q, r);
	    k2 = dx * fnk(y+l1/2);
	    l2 = dx * fnl(t+dx/2, y+l1/2, x+k1/2, p, q, r);
	    k3 = dx * fnk(y+l2/2);
	    l3 = dx * fnl(t+dx/2, y+l2/2, x+k2/2, p, q, r);
	    k4 = dx * fnk(y+l3);
	    l4 = dx * fnl(t+dx, y+l3, x+k3, p, q, r);
	    x += (k1+2*k2+2*k3+k4)/6;
	    y += (l1+2*l2+2*l3+l4)/6;
	}
    }

    public double fnk(double y) {
	return y;
    }
    public double fnl(double t, double y, double x, 
		      double p, double q, double r) {
	return A*Math.sin(r*t)-p*y-q*x;
    }
}
